unit GameButtons;

interface

uses Classes, CastleControls, CastleVectors;

type
  TButtons = class

    public
    //for looking
    class var ToLeft: TCastleButton;
    class var ToForward: TCastleButton;
    class var ToBack: TCastleButton;
    class var ToRight: TCastleButton;
    class var MoveForward: TCastleButton;
    class var MoveBackward: TCastleButton;

    // f, b, l, r = look directions; MF, MB = move directtions
    class var FF: boolean;
    class var FB: boolean;
    class var FL: boolean;
    class var FR: boolean;
    class var FMF: boolean;
    class var FMB: boolean;
    class var FFPressed: boolean;
    class var FBPressed: boolean;
    class var FLPressed: boolean;
    class var FRPressed: boolean;

    class procedure SetF(const F: boolean); static;
    class procedure SetB(const B: boolean); static;
    class procedure SetL(const L: boolean); static;
    class procedure SetR(const R: boolean); static;
    class procedure SetMF(const MF: boolean); static;
    class procedure SetMB(const MB: boolean); static;
    class procedure SetFPressed(const F: boolean); static;
    class procedure SetBPressed(const B: boolean); static;
    class procedure SetLPressed(const L: boolean); static;
    class procedure SetRPressed(const R: boolean); static;

    procedure Init;
    //if is for look direction, assuming from spawn
    procedure IfLeft;
    procedure IfRight;
    procedure IfForward;
    procedure IfBack;

    class property F: boolean read FF write SetF;
    class property B: boolean read FB write SetB;
    class property L: boolean read FL write SetL;
    class property R: boolean read FR write SetR;
    class property MF: boolean read FMF write SetMF;
    class property MB: boolean read FMB write SetMB;
    class property FPressed: boolean read FFPressed write SetFPressed;
    class property BPressed: boolean read FBPressed write SetBPressed;
    class property LPressed: boolean read FLPressed write SetLPressed;
    class property RPressed: boolean read FRPressed write SetRPressed;

  end;

  ButtonPosition = record
  OnLeft: TVector2;
  OnRight: TVector2;
  end;

implementation

    class procedure TButtons.SetF(const F: boolean);
    begin
     FF := F;
    end;

    class procedure TButtons.SetB(const B: boolean);
    begin
     FB := B;
    end;

    class procedure TButtons.SetL(const L: boolean);
    begin
     FL := L;
    end;

    class procedure TButtons.SetR(const R: boolean);
    begin
     FR := R;
    end;

    class procedure TButtons.SetMF(const MF: boolean);
    begin
     FMF := MF;
    end;

    class procedure TButtons.SetMB(const MB: boolean);
    begin
     FMB := MB;
    end;
    class procedure TButtons.SetFPressed(const F: boolean);
    begin
     FFPressed := F;
    end;

    class procedure TButtons.SetBPressed(const B: boolean);
    begin
     FBPressed := B;
    end;

    class procedure TButtons.SetLPressed(const L: boolean);
    begin
     FLPressed := L;
    end;

    class procedure TButtons.SetRPressed(const R: boolean);
    begin
     FRPressed := R;
    end;

procedure TButtons.Init;
begin
     ToLeft.Exists := true;
     ToRight.Exists := true;
     ToForward.Exists := false;
     ToBack.Exists := false;
     ToLeft.Translation := Vector2(739,90);
     ToRight.Translation := Vector2(819,90);
     F := true;
     B := false;
     L := false;
     R := false;
end;

procedure TButtons.IfLeft;
begin
     ToLeft.Exists := false;
     ToRight.Exists := false;
     ToForward.Exists := true;
     ToBack.Exists := true;
     ToBack.Translation := Vector2(739,90);
     ToForward.Translation := Vector2(819,90);
     F := false;
     B := false;
     L := true;
     R := false;
end;

procedure TButtons.IfRight;
begin
     ToLeft.Exists := false;
     ToRight.Exists := false;
     ToForward.Exists := true;
     ToBack.Exists := true;
     ToForward.Translation := Vector2(739,90);
     ToBack.Translation := Vector2(819,90);
     F := false;
     B := false;
     L := false;
     R := true;
end;

procedure TButtons.IfBack;
begin
     ToLeft.Exists := true;
     ToRight.Exists := true;
     ToForward.Exists := false;
     ToBack.Exists := false;
     ToRight.Translation := Vector2(739,90);
     ToLeft.Translation := Vector2(819,90);
     F := false;
     B := true;
     L := false;
     R := false;
end;

procedure TButtons.IfForward;
begin
     ToLeft.Exists := true;
     ToRight.Exists := true;
     ToForward.Exists := false;
     ToBack.Exists := false;
     ToLeft.Translation := Vector2(739,90);
     ToRight.Translation := Vector2(819,90);
     F := true;
     B := false;
     L := false;
     R := false;
end;

end.
