unit GameMovement;

interface

uses Classes, CastleCameras, CastleVectors, CastleTransform, CastleViewport, Castlewindow, GameButtons;

type
  TMovement = class

  {note, the property's name is a single character, W and S for forward and back (as if it were the keys)
  F, B, L, R are Directions - forward, back, left, right (assuming from spawn)}
  strict private

  public

  class var Viewport: TCastleViewport;
  class var Nav: TCastleWalkNavigation;
  class var Camera: TCastleCamera;

  procedure Core;
  procedure Wrapper;
  procedure Init;
  procedure Turn;
  procedure Move(var F: boolean; var B: boolean);



  end;

implementation

var
  Buttons: TButtons;


  procedure TMovement.Init;
  begin
  Nav.Input_Jump.MakeClear();
  Nav.Input_Crouch.MakeClear();
  Nav.Input_Run.MakeClear();
  Nav.Input_RightStrafe.MakeClear();
  Nav.Input_LeftStrafe.MakeClear();
  Nav.Input_Forward.MakeClear();
  Nav.Input_Backward.MakeClear();
  Nav.MoveSpeed := 120;
  Nav.PreferredHeight := 4.5;
  end;

  procedure TMovement.Core;
  begin
  Wrapper;
  end;

  procedure TMovement.Wrapper;
  var
    ForwardCall: boolean;
    BackCall: boolean;
  begin
       ForwardCall := Buttons.MF;
       BackCall := Buttons.MB;
       Turn;
       Move(ForwardCall, BackCall);
  end;

  procedure TMovement.Turn;
  var
     F: boolean;
     B: boolean;
     L: boolean;
     R: boolean;
  begin
     F := Buttons.F;
     B := Buttons.B;
     L := Buttons.L;
     R := Buttons.R;

     if F = true then begin
     Camera.Direction := Vector3(0,0,-1);
     Buttons.IfForward;
     end;
     if B = true then begin
     Camera.Direction := Vector3(0,0,1);
     Buttons.IfBack;
     end;
     if L = true then begin
     Camera.Direction := Vector3(-1,0,0);
     Buttons.IfLeft;
     end;
     if R = true then begin
     Camera.Direction := Vector3(1,0,0);
     Buttons.IfRight;
     end;
  end;

  procedure TMovement.Move(var F: boolean; var B: boolean);
  begin
  if ((F = true) and (B = false)) then begin
  Nav.MoveForward := true;
  Nav.MoveBackward := false;
  end;


  if ((F = false) and (B = true)) then begin
  Nav.MoveForward := false;
  Nav.MoveBackward := true;
  end;

  if ((F = false) and (B = false)) then begin
  Nav.MoveForward := false;
  Nav.MoveBackward := false;
  end;

  end;


end.
