unit GameVariables;

interface

type
  TVariables = class

    strict private
    class var FHP: shortint;
    class procedure SetHP(const Health: shortint); static;

    class var FGunLoaded: boolean;
    class procedure SetGunLoaded(const Loaded: boolean); static;

    class var FGunEquipped: boolean;
    class procedure SetGunEquipped(const Equipped: boolean); static;

    class var FGunUnlocked: boolean;
    class procedure SetGunUnlocked(const Unlocked: boolean); static;

    public
    class property HP: shortint read FHP write SetHP;
    class property GunLoaded: boolean read FGunLoaded write SetGunLoaded;
    class property GunEquipped: boolean read FGunEquipped write SetGunEquipped;
    class property GunUnlocked: boolean read FGunUnlocked write SetGunUnlocked;

    procedure TakeDamage;
    procedure Heal;
    procedure SpawnHP;

    procedure WeaponRules;
    procedure TakeAim;
    procedure Fire;

    procedure WeaponsOnSpawn;

    procedure Spawn;
  end;

implementation

   class procedure TVariables.SetHP(const Health: shortint);
   begin
      FHP := Health;
   end;

   class procedure TVariables.SetGunLoaded(const Loaded: boolean);
   begin
      FGunLoaded := Loaded;
   end;

   class procedure TVariables.SetGunEquipped(const Equipped: boolean);
   begin
      FGunEquipped := Equipped
   end;

   class procedure TVariables.SetGunUnlocked(const Unlocked: boolean);
   begin
      FGunUnlocked := Unlocked;
   end;

   procedure TVariables.TakeDamage;
   begin
      HP := HP - 1;
   end;

   procedure TVariables.Heal;
   begin
      HP := HP + 1;
   end;

   procedure TVariables.SpawnHP;
   begin
      HP := 5;
   end;

   procedure TVariables.TakeAim;
   begin
     GunLoaded := true;
   end;

   procedure TVariables.Fire;
   begin
      GunLoaded := false;
   end;

   procedure TVariables.WeaponRules;
   begin

      //Gun Can't be loaded if not unlocked nor equipped
   if GunUnlocked = false then GunEquipped := false;
   if GunEquipped = false then GunLoaded := false;
   {if Gun = true then begin
   Saw := false;
   Hand := false;
   Candle := false;
   end;

   if Saw = true then begin
   Gun := false;
   Hand := false;
   Candle := false;
   end;

   if Hand = true then begin
   Saw := false;
   Gun := false;
   Candle := false;
   end;

   if Candle = true then begin
   Saw := false;
   Hand := false;
   Gun := false;
   end;}
   end;

   procedure TVariables.WeaponsOnSpawn;
   begin
      GunUnlocked := false;
   end;

   procedure TVariables.Spawn;
   begin
      SpawnHP;
   end;

end.
