unit GameViewPause;

interface

uses Classes,
  CastleVectors, CastleUIControls, CastleControls, CastleKeysMouse, CastleScene, GameAnimations, CastleWindow;

type
  TViewPause = class(TCastleView)
  published
    { Components designed using CGE editor.
      These fields will be automatically initialized at Start. }
    // ButtonXxx: TCastleButton;
    Menu: TCastleScene;
    ReturnToIGM: TCastleButton;
    ReturnToMain: TCastleButton;
    ReturnToDesktop: TCastleButton;
    ReturnToGame: TCastleButton;
    OpenSettings: TCastleButton;

    private
      procedure ClickReturnToIGM (Sender:TObject);
      procedure ClickReturnToMain (Sender:TObject);
      procedure ClickReturnToDesktop (Sender:TObject);
      procedure ClickReturnToGame (Sender:TObject);
      procedure ClickOpenSettings(Sender:TObject);

  public
    constructor Create(AOwner: TComponent); override;
    procedure Start; override;
    procedure Update(const SecondsPassed: Single; var HandleInput: boolean); override;
  end;

var
  ViewPause: TViewPause;
  Animations: TAnimations;

implementation

constructor TViewPause.Create(AOwner: TComponent);
begin
  inherited;
  DesignUrl := 'castle-data:/gameviewpause.castle-user-interface';
end;

procedure TViewPause.ClickReturnToIGM(Sender:TObject);
begin
 ReturnToMain.Exists := true;
 ReturnToDesktop.Exists := true;
 ReturnToGame.Exists := true;
 OpenSettings.Exists := true;
 ReturnToIGM.Exists := false;
end;

procedure TViewPause.ClickReturnToMain(Sender:TObject);
begin

end;

procedure TViewPause.ClickReturnToDesktop(Sender:TObject);
begin

end;

procedure TViewPause.ClickReturnToGame(Sender:TObject);
begin

end;

procedure TViewPause.ClickOpenSettings(Sender:TObject);
begin

end;

procedure TViewPause.Start;
begin
  inherited;
  { Executed once when view starts. }
  ReturnToIGM.OnClick := {$ifdef FPC}@{$endif}ClickReturnToIGM;
  ReturnToMain.OnClick := {$ifdef FPC}@{$endif}ClickReturnToMain;
  ReturnToDesktop.OnClick := {$ifdef FPC}@{$endif}ClickReturnToDesktop;
  ReturnToGame.OnClick := {$ifdef FPC}@{$endif}ClickReturnToGame;
  OpenSettings.OnClick := {$ifdef FPC}@{$endif}ClickOpenSettings;
  Menu.AnimationTimeSensor('Open').Start (false,true);
end;

procedure TViewPause.Update(const SecondsPassed: Single; var HandleInput: boolean);
begin
  inherited;
  { Executed every frame. }
end;

end.
