unit GameViewPlay;

interface

uses Classes,
  CastleVectors, CastleUIControls, CastleControls, CastleKeysMouse, CastleTransform, CastleCameras, CastleScene, GameRegulation, GameViewHud;

type
  TViewPlay = class(TCastleView)
  published
    { Components designed using CGE editor.
      These fields will be automatically initialized at Start. }
    // ButtonXxx: TCastleButton;
    Nav: TCastleWalkNavigation;

  strict private
  class var FForwardClicked: boolean;
  class procedure SetForwardClicked(const Clicked: boolean); static;
  class var FBackwardClicked: boolean;
  class procedure SetBackwardClicked(const Clicked: boolean); static;

  public
    constructor Create(AOwner: TComponent); override;
    procedure Start; override;
    procedure Update(const SecondsPassed: Single; var HandleInput: boolean); override;
    procedure MoveForward;
    procedure MoveBackward;

  end;

var
  ViewPlay: TViewPlay;
  ViewHud: TViewHud;
  Regulation: TGameRegulation;
implementation

constructor TViewPlay.Create(AOwner: TComponent);
begin
  inherited;
  DesignUrl := 'castle-data:/gameviewplay.castle-user-interface';
end;

procedure TViewPlay.Start;
begin
  inherited;
  { Executed once when view starts. }
end;
 
class procedure TViewPlay.SetForwardClicked(const Clicked: boolean);
begin
  FForwardClicked := Clicked;
end;

class procedure TViewPlay.SetBackwardClicked(const Clicked: boolean);
begin
 FBackwardClicked := Clicked;
end;

procedure TViewPlay.MoveForward;
begin
     Nav.MoveForward := true
end;

procedure TViewPlay.MoveBackward;
begin
  Nav.MoveBackward := true;
end;

procedure TViewPlay.Update(const SecondsPassed: Single; var HandleInput: boolean);
begin
  inherited;
  { Executed every frame. }
end;

end.
