unit GameViewSceneOne;

interface

uses Classes,
  CastleVectors, CastleUIControls, CastleControls, CastleKeysMouse, CastleCameras, CastleScene, CastleSceneCore, CastleViewport, CastleTransform, GameViewOffice;

type
  TViewSceneOne = class(TCastleView)
  published
    { Components designed using CGE editor.
      These fields will be automatically initialized at Start. }
    // ButtonXxx: TCastleButton;
    Base, Nicu: TCastleScene;
    Camera: TCastleCamera;
    Dialogue: TCastleDesign;
    Chatbox: TCastleImageControl;
    ContinueButton: TCastleButton;
    Intro1, Intro2, Intro3, Intro4, Intro5: TCastleImageControl;
    Speaking: TCastleDesign;
  private 
  Clicks: integer;
  procedure DialogueWorkings;
  procedure ClickContinue(Sender: TObject);
  public
    constructor Create(AOwner: TComponent); override;
    procedure Start; override;
    procedure Update(const SecondsPassed: Single; var HandleInput: boolean); override;
  end;

var
  ViewSceneOne: TViewSceneOne;
  Office: TViewOffice;

implementation


constructor TViewSceneOne.Create(AOwner: TComponent);
begin
  inherited;
  DesignUrl := 'castle-data:/gameviewsceneone.castle-user-interface';
end;

procedure TViewSceneOne.Start;
begin
  inherited;
  { Executed once when view starts. }
  ContinueButton.OnClick := {$ifdef FPC} @ {$endif} ClickContinue;
  Clicks := 0;
end;

procedure TViewSceneOne.ClickContinue(Sender: TObject);
begin 
Clicks := Clicks + 1;
end;

procedure TViewSceneOne.DialogueWorkings;
begin 
if Clicks = 0 then begin 
Intro1.Exists := true;
Intro2.Exists := false;
Base.PlayAnimation('WalkIn', false, true);
end;
if Clicks = 1 then begin 
Intro1.Exists := false;
Intro2.Exists := true;
Base.PlayAnimation('SitDown', false, true);
end;
if Clicks = 2 then begin 
Intro2.Exists := false;
Intro3.Exists := true;

end;
if Clicks = 3 then begin 
Intro3.Exists := false;
Intro4.Exists := true;
Base.PlayAnimation('Forfeit', false, true);
end;
if Clicks = 4 then begin 
Intro4.Exists := false;
Intro5.Exists := true;

end;
if Clicks = 5 then begin 
Intro5.Exists := false;
Container.View := ViewOffice;
end;
end;


procedure TViewSceneOne.Update(const SecondsPassed: Single; var HandleInput: boolean);
begin
  inherited;
  { Executed every frame. }
  DialogueWorkings;
end;

end.
