unit GameViewSceneOneDialogue;

interface

uses Classes,
  CastleVectors, CastleUIControls, CastleControls, CastleKeysMouse, CastleCameras, CastleTransform, CastleScene, CastleColors, castleviewport;

type
  TViewSceneOneDialogue = class(TCastleView)
  published
    { Components designed using CGE editor.
      These fields will be automatically initialized at Start. }
    // ButtonXxx: TCastleButton;
    ChatBox: TCastleScene;
    Camera: TCastleCamera;
    Viewport: TCastleViewport;
    ContinueButton: TCastleButton;
  
  private
  procedure LineWork;
  procedure regulation;
  public
    constructor Create(AOwner: TComponent); override;
    procedure Start; override;
    procedure Update(const SecondsPassed: Single; var HandleInput: boolean); override;
    procedure ClickContinue(Sender: TObject);
  end;

var
  ViewSceneOneDialogue: TViewSceneOneDialogue;
  Continue: boolean;
  Speaking, Listening: boolean;
  LineOne, LineTwo, LineThree, LineFour, LineFive, LineSix, LineSeven: boolean;

implementation

uses gameviewsceneone;

constructor TViewSceneOneDialogue.Create(AOwner: TComponent);
begin
  inherited;
  DesignUrl := 'castle-data:/gameviewsceneonedialogue.castle-user-interface';
end;

procedure TViewSceneOneDialogue.LineWork;
begin
if LineOne = true then begin 
ChatBox.AnimationTimeSensor('Intro1Exists').Start (false, true);
ChatBox.AnimationTimeSensor('Intro2DoesNotExist').Start (false, true);
ChatBox.AnimationTimeSensor('Intro3DoesNotExist').Start (false, true);
ChatBox.AnimationTimeSensor('Intro4DoesNotExist').Start (false, true);
ChatBox.AnimationTimeSensor('Intro5DoesNotExist').Start (false, true);
ChatBox.AnimationTimeSensor('Intro6DoesNotExist').Start (false, true);
ChatBox.AnimationTimeSensor('Intro7DoesNotExist').Start (false, true);
LineTwo := false;
LineThree := false;
LineFour := false;
LineFive := false;
LineSix := false;
LineSeven := false;
end;
if LineTwo = true then begin 
ChatBox.AnimationTimeSensor('Intro1DoesNotExist').Start (false, true);
ChatBox.AnimationTimeSensor('Intro2Exists').Start (false, true);
ChatBox.AnimationTimeSensor('Intro3DoesNotExist').Start (false, true);
ChatBox.AnimationTimeSensor('Intro4DoesNotExist').Start (false, true);
ChatBox.AnimationTimeSensor('Intro5DoesNotExist').Start (false, true);
ChatBox.AnimationTimeSensor('Intro6DoesNotExist').Start (false, true);
ChatBox.AnimationTimeSensor('Intro7DoesNotExist').Start (false, true);
LineOne := false;
LineThree := false;
LineFour := false;
LineFive := false;
LineSix := false;
LineSeven := false;
end;
if LineThree = true then begin 
ChatBox.AnimationTimeSensor('Intro1DoesNotExist').Start (false, true);
ChatBox.AnimationTimeSensor('Intro2DoesNotExist').Start (false, true);
ChatBox.AnimationTimeSensor('Intro3Exists').Start (false, true);
ChatBox.AnimationTimeSensor('Intro4DoesNotExist').Start (false, true);
ChatBox.AnimationTimeSensor('Intro5DoesNotExist').Start (false, true);
ChatBox.AnimationTimeSensor('Intro6DoesNotExist').Start (false, true);
ChatBox.AnimationTimeSensor('Intro7DoesNotExist').Start (false, true);
LineTwo := false;
LineOne := false;
LineFour := false;
LineFive := false;
LineSix := false;
LineSeven := false;
end;
if LineFour = true then begin 
ChatBox.AnimationTimeSensor('Intro1DoesNotExist').Start (false, true);
ChatBox.AnimationTimeSensor('Intro2DoesNotExist').Start (false, true);
ChatBox.AnimationTimeSensor('Intro3DoesNotExist').Start (false, true);
ChatBox.AnimationTimeSensor('Intro4Exists').Start (false, true);
ChatBox.AnimationTimeSensor('Intro5DoesNotExist').Start (false, true);
ChatBox.AnimationTimeSensor('Intro6DoesNotExist').Start (false, true);
ChatBox.AnimationTimeSensor('Intro7DoesNotExist').Start (false, true);
LineTwo := false;
LineThree := false;
LineOne := false;
LineFive := false;
LineSix := false;
LineSeven := false;
end;
if LineFive = true then begin 
ChatBox.AnimationTimeSensor('Intro1DoesNotExist').Start (false, true);
ChatBox.AnimationTimeSensor('Intro2DoesNotExist').Start (false, true);
ChatBox.AnimationTimeSensor('Intro3DoesNotExist').Start (false, true);
ChatBox.AnimationTimeSensor('Intro4DoesNotExist').Start (false, true);
ChatBox.AnimationTimeSensor('Intro5Exists').Start (false, true);
ChatBox.AnimationTimeSensor('Intro6DoesNotExist').Start (false, true);
ChatBox.AnimationTimeSensor('Intro7DoesNotExist').Start (false, true);
LineTwo := false;
LineThree := false;
LineFour := false;
LineOne := false;
LineSix := false;
LineSeven := false;
end;
if LineSix = true then begin 
ChatBox.AnimationTimeSensor('Intro1DoesNotExist').Start (false, true);
ChatBox.AnimationTimeSensor('Intro2DoesNotExist').Start (false, true);
ChatBox.AnimationTimeSensor('Intro3DoesNotExist').Start (false, true);
ChatBox.AnimationTimeSensor('Intro4DoesNotExist').Start (false, true);
ChatBox.AnimationTimeSensor('Intro5DoesNotExist').Start (false, true);
ChatBox.AnimationTimeSensor('Intro6Exists').Start (false, true);
ChatBox.AnimationTimeSensor('Intro7DoesNotExist').Start (false, true);
LineTwo := false;
LineThree := false;
LineFour := false;
LineFive := false;
LineOne := false;
LineSeven := false;
end;
if LineSeven = true then begin 
ChatBox.AnimationTimeSensor('Intro1DoesNotExist').Start (false, true);
ChatBox.AnimationTimeSensor('Intro2DoesNotExist').Start (false, true);
ChatBox.AnimationTimeSensor('Intro3DoesNotExist').Start (false, true);
ChatBox.AnimationTimeSensor('Intro4DoesNotExist').Start (false, true);
ChatBox.AnimationTimeSensor('Intro5DoesNotExist').Start (false, true);
ChatBox.AnimationTimeSensor('Intro6DoesNotExist').Start (false, true);
ChatBox.AnimationTimeSensor('Intro7Exists').Start (false, true);
LineTwo := false;
LineThree := false;
LineFour := false;
LineFive := false;
LineSix:= false;
LineOne := false;
end;
end;

procedure TViewSceneOneDialogue.Regulation;
begin 
if Speaking = true then begin 
  ChatBox.AnimationTimeSensor('MouthExists').Start (false, true);
  ChatBox.AnimationTimeSensor('Speaking').Start (true, true);
  ChatBox.AnimationTimeSensor('ListeningWaveDoesNotExist').Start (false, true);
  ChatBox.AnimationTimeSensor('ListeningEarDoesNotExist').Start (false, true);
end;
if Listening = true then begin 
  ChatBox.AnimationTimeSensor('MouthDoesNotExist').Start (false, true);
  ChatBox.AnimationTimeSensor('Speaking').Stop;
  ChatBox.AnimationTimeSensor('ListeningWaveExists').Start (false, true);
  ChatBox.AnimationTimeSensor('ListeningEarExists').Start (false, true);
  ChatBox.AnimationTimeSensor('Listening').Start (true, true);
  end;
if Speaking = true then Listening := false;
if Listening = true then Speaking := false;
end;

procedure TViewSceneOneDialogue.Start;
begin
  inherited;
  { Executed once when view starts. }
  ContinueButton.OnClick := {$ifdef FPC}@{$endif} ClickContinue;
  Speaking := true;
  LineOne := true;
end;

procedure TViewSceneOneDialogue.ClickContinue(Sender: TObject);
begin 
if LineOne = true then LineTwo := true;
if LineTwo = true then LineThree := true;
if LineThree = true then LineFour := true;
if LineFour = true then LineFive := true;
if LineFive = true then LineSix := true;
if LineSix = true then LineSeven := true;
if LineSeven = true then Container.PopView(self);
end;

procedure TViewSceneOneDialogue.Update(const SecondsPassed: Single; var HandleInput: boolean);
var 
  View: TViewSceneOneDialogue;
begin
  inherited;
  { Executed every frame. }
  Regulation;
  LineWork;
end;

end.
